<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="style.css">
    <style>@import url('https://fonts.googleapis.com/css2?family=Pacifico&display=swap');</style>
    <title>Calculate</title>
</head>
<body>
    <header>
        <img class="logo" src="calculate.svg" alt="image of calculate making the logo of the website">
        <h1>Let's calculate</h1> 
    </header>

        <div class="calculator">

            <input type="text" class="calculator-screen" value="" disabled />
            
            <div class="calculator-keys">
              
          <div class="first-row">
              <button type="button" class="number"value="7">7</button>
              <button type="button" class="number"value="8">8</button>
              <button type="button" class="number"value="9">9</button>
              <button type="button" class="operator" value="+">+</button>
          </div>
              <div class="second-row">
          
              <button type="button" class="number"value="4">4</button>
              <button type="button" class="number"value="5">5</button>
              <button type="button" class="number"value="6">6</button>
              <button type="button" class="operator" value="-">-</button>

          </div>
              <div class="third-row">
              <button type="button" class="number"value="1">1</button>
              <button type="button" class="number"value="2">2</button>
              <button type="button" class="number"value="3">3</button>
              <button type="button" class="operator" value="*">&times;</button>

          </div>
              <div class="fourth-row">
              <button type="button" class="number"value="0">0</button>
              <button type="button" class="number" value=".">.</button>
              <button type="button" class="number" value="all-clear">AC</button>
              <button type="button" class="number" value="/">&divide;</button>
          </div>
          <button type="button" class="equal-sign operator" value="=">=</button>
            </div>
          </div>
          <script>
              const calculator = {
                displayValue: '0',
                firstOperand: null,
                waitingForSecondOperand: false,
                operator: null,
                };

                function inputDigit(digit) {
                const { displayValue, waitingForSecondOperand } = calculator;

                if (waitingForSecondOperand === true) {
                calculator.displayValue = digit;
                calculator.waitingForSecondOperand = false;
                } else {
                calculator.displayValue = displayValue === '0' ? digit : displayValue + digit;
                }
                }

                function inputDecimal(dot) {
                  if (calculator.waitingForSecondOperand === true) {
                  	calculator.displayValue = "0."
                    calculator.waitingForSecondOperand = false;
                    return
                  }
              
                  if (!calculator.displayValue.includes(dot)) {
                    calculator.displayValue += dot;
                  }
                }

                function handleOperator(nextOperator) {
                  const { firstOperand, displayValue, operator } = calculator
                    const inputValue = parseFloat(displayValue);
  
                    if (operator && calculator.waitingForSecondOperand)  {
                      calculator.operator = nextOperator;
                      return;
                    }


                    if (firstOperand == null && !isNaN(inputValue)) {
                      calculator.firstOperand = inputValue;
                    } else if (operator) {
                      const result = calculate(firstOperand, inputValue, operator);

                      calculator.displayValue = `${parseFloat(result.toFixed(7))}`;
                      calculator.firstOperand = result;
                    }

                    calculator.waitingForSecondOperand = true;
                    calculator.operator = nextOperator;
                    }

                    function calculate(firstOperand, secondOperand, operator) {
                    if (operator === '+') {
                      return firstOperand + secondOperand;
                    } else if (operator === '-') {
                      return firstOperand - secondOperand;
                    } else if (operator === '*') {
                      return firstOperand * secondOperand;
                    } else if (operator === '/') {
                      return firstOperand / secondOperand;
                    }

                    return secondOperand;
                    }

                    function resetCalculator() {
                    calculator.displayValue = '0';
                     calculator.firstOperand = null;
                    calculator.waitingForSecondOperand = false;
                    calculator.operator = null;
                    }

                    function updateDisplay() {
                     const display = document.querySelector('.calculator-screen');
                    display.value = calculator.displayValue;
                    }

                    updateDisplay();

                    const keys = document.querySelector('.calculator-keys');
                    keys.addEventListener('click', event => {
                    const { target } = event;
                    const { value } = target;
                    if (!target.matches('button')) {
                      return;
                    }

                    switch (value) {
                      case '+':
                      case '-':
                      case '*':
                      case '/':
                     case '=':
                        handleOperator(value);
                        break;
                      case '.':
                        inputDecimal(value);
                        break;
                      case 'all-clear':
                        resetCalculator();
                        break;
                      default:
                        if (Number.isInteger(parseFloat(value))) {
                          inputDigit(value);
                        }
                    }

                    updateDisplay();
                    });
          </script>
</body>
</html>
